<p align="center">✨Dvurechensky✨</p>
<p align="center">
    <p align="center">
        <img src="Git/gitPreview.png" width="100%" alt="Banner">
    <a></a>
    <p align="center">
        <a href="https://git.io/typing-svg"><img src="https://readme-typing-svg.demolab.com?font=Fira+Code&pause=1000&center=true&vCenter=true&width=435&lines=%D0%9F%D0%BE%D0%B2%D1%82%D0%BE%D1%80%D0%B5%D0%BD%D0%B8%D0%B5+-+%D0%BC%D0%B0%D1%82%D1%8C+%D1%83%D1%87%D0%B5%D0%BD%D0%B8%D1%8F" alt="Typing SVG" /></a>
    </p>
    <p align="center">
        <a href="https://sites.google.com/view/dvurechensky" target="_blank"><img alt="Static Badge" src="https://shields.dvurechensky.pro/badge/Dvurechensky-N-blue"></a>
        <img src="https://shields.dvurechensky.pro/badge/Csharp-VS2022-blue?logo=csharp&logoColor=FFFF00">
    </p>
</p>

# Разбор языка программирования C# 🍧

## 🔰 Зависимости 
- runtime-5.0.17 - **.NET 5.0 Desktop** - где [**скачать?**](https://dotnet.microsoft.com/en-us/download/dotnet/5.0/runtime?cid=getdotnetcore&os=windows&arch=x64)

## ♨️ Содержание

### Темы 🏀


- 💥 Типы данных
- 💥 Переменные в языке
- 💥 Разбор классов **Convert, Parse, TryParse**
- 💥 Арифметические операции с числами и их приоритет выполнения
- 💥 Создание несколько проектов в одном решении
- 💥 Постфиксный и префиксный инкремент и декремент
- 💥 **Операторы** и **операции сравнения**
- 💥 Логические **операторы** и сокращённые логические операции
- 💥 Тернарный **оператор** и его примеры
- 💥 **Оператор** присваивания и объединения со значением NULL
- 💥 **Операторы** - as и is
- 💥 Конструкции **if~else**, **switch**
- 💥 Циклы **while**, **do~while**, **for** и **for** - в обратном порядке, **вложенные циклы**
- 💥 Ключевые слова **break**, **contine**, **ref**, **out**, **params**, **this**, **base**, **this в конструкторе**, модификатор **in**
- 💥 Массивы - **одномерные**, **многомерные**, **ступенчатые(зубчатые)** и **трёхмерные**
- 💥 **Перегрузка** методов
- 💥 Область видимости, контекст переменной, конфликт областей
- 💥 **Ссылочные** и **значимые** типы, **стек** и **куча**
- 💥 Что такое **NULL**
- 💥 Варианты параметров метода
- 💥 Что такое **рекурсия**, переполнение стека
- 💥 Преобразование и приведение, явное и неявное
- 💥 Арифметическое переполнение, **checked** и **unchecked**
- 💥 Что такое **Nullable**, Null совместимые значимые типы Nullable
- 💥 **Var** - неявно типизированные переменные
- 💥 **Еnum** - что это, и для чего нужно
- 💥 Что такое **Class**(ООП), **объект(object)**, **экземпляр** класса
- 💥 **Методы** и **классы**, **вызов метода** экземпляра класса
- 💥 Модификаторы доступа - **public**, **protected**, **private**
- 💥 **Инкапсуляция** с примерами
- 💥 Что такое **конструктор** класса
- 💥 **Перегрузка конструкторов** класса
- 💥 **Полиморфизм** с примерами
- 💥 Виртуальные методы, **virtual** и **override**
- 💥 **Абстрактные(abstract) классы**
- 💥 **Интерфейсы(interface)**, зачем нужны и как используются
- 💥 **Наследование** интерфейсов, **множественное наследование**
- 💥 Структуры(struct) и классы(class) - **отличия**
- 💥 **Упаковка(boxing)** и **распаковка(unboxing)** значимых(value)типов
- 💥 Обобщения, **Generic** типы, методы и классы

### Задачи ⚽

- 🌟 Среднее арифметическое двух чисел
- 🌟 Введите три числа и выведите их произведение и суммы
- 🌟 Конвертер валюты
- 🌟 Проверка числа на чётность
- 🌟 Калькулятор на **Switch** и **If~Else**
- 🌟 Как нарисовать треугольник в консоли

Данная информация по C# проработанна мной с плейлиста грамотного канала 👊 [#SimpleCode](https://www.youtube.com/playlist?list=PLQOaTSbfxUtD6kMmAYc8Fooqya3pjLs1N) 👊

<p align="center">✨Dvurechensky✨</p>